public interface NewCollection<E> {
    // Overview: Tipo modificabile che rappresenta una collezione indicizzata di elementi di E
    // Typical Element: {<e_1, i_1>, ..., <e_k,i_k>} collezione indicizzata di elementi di tipo E

    /* inserisce l'elemento elem nella collezione alla posizione p,
       spostando l'elemento contenuto in precedenza in una posizione libera */
    public void insertAt(E elem, int p) throws NullPointerException;
    /*
        MODIFIES: this
        EFFECTS: se elem != null lo inserisce nella collezione nella posizione indicata,
        altrimenti lancia una NullPointerException (eccezione disponibile in Java, unchecked);
        se la posizione era gia' occupata sposta l'elemento nella prima posizione libera
     */
      
     /* restituisce l'elemento alla posizione p nella collezione */
     public E get(int p);
     /*
        EFFECTS: restituisce l'elemento contenuto nella posizione p, null se la posizione e' libera
     */
    
    
     /* restituisce la posizione della prima occorrenza dell'elemento elem,
        altrimenti -1 se elem non appartiene alla collezione */
     public int indexOf(E elem) throws NullPointerException;
     /*
        EFFECTS: se elem != null restituisce la sua posizione piu' piccola nella collezione,
        altrimenti lancia una NullPointerException (eccezione disponibile in Java, unchecked)
     */
}